diff -uNrd -x CVS ircd-hybrid-7rc5/src/s_user.c ircd-hybrid-7-bg/src/s_user.c
--- ircd-hybrid-7rc5/src/s_user.c	Wed Oct 30 16:53:30 2002
+++ ircd-hybrid-7-bg/src/s_user.c	Mon Mar 10 01:09:06 2003
@@ -19,10 +19,11 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_user.c,v 7.214 2002/10/30 21:53:30 androsyn Exp $
+ *  $Id: s_user.c,v 1.7 2003/03/10 06:09:06 demond Exp $
  */
 
 #include "stdinc.h"
+#include "config.h"
 #include "tools.h"
 #include "s_user.h"
 #include "channel.h"
@@ -58,7 +59,7 @@
 static void report_and_set_user_flags( struct Client *, struct ConfItem * );
 static int check_X_line(struct Client *client_p, struct Client *source_p);
 void user_welcome(struct Client *source_p);
-static int introduce_client(struct Client *client_p, struct Client *source_p,
+int introduce_client(struct Client *client_p, struct Client *source_p,
 			    struct User *user, char *nick);
 int oper_up( struct Client *source_p, struct ConfItem *aconf );
 
@@ -77,6 +78,7 @@
   {FLAGS_BOTS,  'b'},
   {FLAGS_CCONN, 'c'},
   {FLAGS_DEBUG, 'd'},
+  {FLAGS_ALTLOCALE, 'e'},
   {FLAGS_FULL,  'f'},
   {FLAGS_CALLERID, 'g'},
   {FLAGS_INVISIBLE, 'i'},
@@ -84,6 +86,7 @@
   {FLAGS_LOCOPS, 'l'},
   {FLAGS_NCHANGE, 'n'},
   {FLAGS_OPER, 'o'},
+  {FLAGS_REMOTE, 'q'},
   {FLAGS_REJ, 'r'},
   {FLAGS_SERVNOTICE, 's'},
   {FLAGS_UNAUTH, 'u'},
@@ -91,6 +94,10 @@
   {FLAGS_EXTERNAL, 'x'},
   {FLAGS_SPY, 'y'},
   {FLAGS_OPERWALL, 'z'},
+  {FLAGS_REGACCEPT, 'R'},
+  {FLAGS_SSLACCEPT, 'S'},
+  {FLAGS_TRANSWIN, 'T'},
+  {FLAGS_TRANSISO, 'Y'},
   {0, 0}
 };
 
@@ -120,14 +127,14 @@
   0,            /* O */
   0,            /* P */
   0,            /* Q */
-  0,            /* R */
-  0,            /* S */
-  0,            /* T */
+  FLAGS_REGACCEPT,/* R */
+  FLAGS_SSLACCEPT,/* S */
+  FLAGS_TRANSWIN,/* T */
   0,            /* U */
   0,            /* V */
   0,            /* W */
   0,            /* X */
-  0,            /* Y */
+  FLAGS_TRANSISO,/* Y */
   0,            /* Z 0x5A */
   0, 0, 0, 0, 0, /* 0x5F */ 
   /* 0x60 */       0,
@@ -135,26 +142,30 @@
   FLAGS_BOTS,   /* b */
   FLAGS_CCONN,  /* c */
   FLAGS_DEBUG,  /* d */
-  0,            /* e */
+  FLAGS_ALTLOCALE,/* e */
   FLAGS_FULL,   /* f */
-  FLAGS_CALLERID,  /* g */
+  FLAGS_CALLERID,/* g */
   0,            /* h */
-  FLAGS_INVISIBLE, /* i */
+  FLAGS_INVISIBLE,/* i */
   0,            /* j */
   FLAGS_SKILL,  /* k */
   FLAGS_LOCOPS, /* l */
   0,            /* m */
   FLAGS_NCHANGE, /* n */
   FLAGS_OPER,   /* o */
-  0,               /* p */
-  0,            /* q */
+  0,            /* p */
+#ifdef UMODEQ  
+  FLAGS_REMOTE, /* q */
+#else  
+  0, 			/* q */
+#endif  
   FLAGS_REJ,    /* r */
   FLAGS_SERVNOTICE, /* s */
   0,            /* t */
   FLAGS_UNAUTH, /* u */
   0,            /* v */
   FLAGS_WALLOP, /* w */
-  FLAGS_EXTERNAL, /* x */
+  FLAGS_EXTERNAL,/* x */
   FLAGS_SPY,    /* y */
   FLAGS_OPERWALL, /* z 0x7A */
   0,0,0,0,0,     /* 0x7B - 0x7F */
@@ -180,43 +191,46 @@
 show_lusers(struct Client *source_p) 
 {
   if(!ConfigServerHide.hide_servers || IsOper(source_p))
-    sendto_one(source_p, form_str(RPL_LUSERCLIENT), me.name, source_p->name,
+    sendto_one(source_p, form_str(source_p,RPL_LUSERCLIENT), me.name, source_p->name,
               (Count.total-Count.invisi), Count.invisi, Count.server);
   else
-    sendto_one(source_p, form_str(RPL_LUSERCLIENT), me.name, source_p->name,
+    sendto_one(source_p, form_str(source_p,RPL_LUSERCLIENT), me.name, source_p->name,
               (Count.total-Count.invisi), Count.invisi, 1);
   if (Count.oper > 0)
-    sendto_one(source_p, form_str(RPL_LUSEROP), me.name, source_p->name,
+    sendto_one(source_p, form_str(source_p,RPL_LUSEROP), me.name, source_p->name,
                Count.oper);
 
   if (Count.unknown > 0)
-    sendto_one(source_p, form_str(RPL_LUSERUNKNOWN), me.name, source_p->name,
+    sendto_one(source_p, form_str(source_p,RPL_LUSERUNKNOWN), me.name, source_p->name,
                Count.unknown);
 
   if (Count.chan > 0)
-    sendto_one(source_p, form_str(RPL_LUSERCHANNELS),
+    sendto_one(source_p, form_str(source_p,RPL_LUSERCHANNELS),
                me.name, source_p->name, Count.chan);
 
   if(!ConfigServerHide.hide_servers || IsOper(source_p))
     {
-      sendto_one(source_p, form_str(RPL_LUSERME),
+      sendto_one(source_p, form_str(source_p,RPL_LUSERME),
                  me.name, source_p->name, Count.local, Count.myserver);
-      sendto_one(source_p, form_str(RPL_LOCALUSERS), me.name, source_p->name,
+      sendto_one(source_p, form_str(source_p,RPL_LOCALUSERS), me.name, source_p->name,
                  Count.local, Count.max_loc);
     }
   else
     {
-      sendto_one(source_p, form_str(RPL_LUSERME),
+      sendto_one(source_p, form_str(source_p,RPL_LUSERME),
                  me.name, source_p->name, Count.total, 0);
-      sendto_one(source_p, form_str(RPL_LOCALUSERS), 
+      sendto_one(source_p, form_str(source_p,RPL_LOCALUSERS), 
                  me.name, source_p->name, Count.total, Count.max_tot);
     }
 
-  sendto_one(source_p, form_str(RPL_GLOBALUSERS), me.name, source_p->name,
+  sendto_one(source_p, form_str(source_p,RPL_GLOBALUSERS), me.name, source_p->name,
              Count.total, Count.max_tot);
 
+  sendto_one(source_p, form_str(source_p,RPL_IDUSERS), me.name, source_p->name,
+             Count.identified, Count.max_identified);
+
   if(!ConfigServerHide.hide_servers || IsOper(source_p))
-    sendto_one(source_p, form_str(RPL_STATSCONN), me.name, source_p->name,
+    sendto_one(source_p, form_str(source_p,RPL_STATSCONN), me.name, source_p->name,
                MaxConnectionCount, MaxClientCount, Count.totalrestartcount);
 
   if (Count.local > MaxClientCount)
@@ -241,11 +255,11 @@
   char isupportbuffer[512];
 
   ircsprintf(isupportbuffer, FEATURES, FEATURESVALUES);
-  sendto_one(source_p, form_str(RPL_ISUPPORT), me.name, source_p->name, 
+  sendto_one(source_p, form_str(source_p,RPL_ISUPPORT), me.name, source_p->name, 
   	     isupportbuffer);
 	     
   ircsprintf(isupportbuffer, FEATURES2, FEATURES2VALUES);
-  sendto_one(source_p, form_str(RPL_ISUPPORT), me.name, source_p->name,
+  sendto_one(source_p, form_str(source_p,RPL_ISUPPORT), me.name, source_p->name,
              isupportbuffer);
 
   return;
@@ -329,6 +343,8 @@
       strncpy(source_p->host,source_p->localClient->sockhost,HOSTIPLEN+1);
     }
 
+  strcpy(source_p->ip, source_p->localClient->sockhost);
+
   ptr = source_p->localClient->confs.head;
   aconf = ptr->data;
 
@@ -373,7 +389,7 @@
       strcmp(source_p->localClient->passwd, aconf->passwd))
     {
       ServerStats->is_ref++;
-      sendto_one(source_p, form_str(ERR_PASSWDMISMATCH),
+      sendto_one(source_p, form_str(source_p,ERR_PASSWDMISMATCH),
 		 me.name, source_p->name);
       (void)exit_client(client_p, source_p, &me, "Bad Password");
       return(CLIENT_EXITED);
@@ -478,6 +494,10 @@
   if (++Count.total > Count.max_tot)
     Count.max_tot = Count.total;
   source_p->localClient->allow_read = MAX_FLOOD_BURST;
+  
+  if (source_p->svsflags & FLAGS_SVS_IDENT)
+    if (++Count.identified > Count.max_identified)
+      Count.max_identified = Count.identified;
 
   Count.totalrestartcount++;
 
@@ -496,9 +516,100 @@
   }
   user_welcome(source_p);
 
+#if 0
+#define NETID "bnet"
+#endif
+
+  if (!IsConfDoSpoofIp(aconf))
+    strcpy(source_p->realhost, source_p->host);
+
+  /* mask the appropriate client host portion:
+   * - leftmost part if resolving host 
+   *   (but not if just one dot in the host)
+   * - rightmost part if numeric IP
+   *                                   -demond
+   */
+#ifdef IPV6
+  if (source_p->localClient->aftype != AF_INET6)
+#endif   
+  if (IsConfMaskHost(aconf))
+    {
+      int alpha = 0, dots = 0;
+      char buf[HOSTLEN + 1];
+      char *p = source_p->host;
+      static char *get_mask(char *, int);
+
+      while (*p) 
+		{
+	  		if (isalpha(*p)) alpha = 1;
+	  		if (*p++ == '.') ++dots;
+		}
+
+      strcpy(buf, source_p->host);
+
+      if (alpha && (dots > 1)) 
+		{
+	  		p = strchr(buf, '.'); *p++ = 0; 
+
+	  		if (strlen(p) + MAXNETID + 6 <= HOSTLEN)
+	    	{
+	      		strcpy(source_p->host, get_mask(buf, 0));
+	      		strcat(source_p->host, p);
+	    	}
+		} 
+      else if (!alpha) 
+		{
+	  		p = strrchr(buf, '.'); *p++ = 0;
+
+	  		if (strlen(buf) + 7 <= HOSTLEN)
+	    	{
+	      		strcpy(source_p->host, buf);
+	      		strcat(source_p->host, get_mask(NULL, atoi(p)));
+	    	}
+		}
+    }
+
+  hash_check_watch(source_p, RPL_LOGON);
+
   return (introduce_client(client_p, source_p, user, nick));
 }
 
+static char *get_mask(char *s, int n)
+{
+  static char buf[MAXNETID + 6];
+  char *p = buf;
+  char *netid = ConfigFileEntry.netid[0]? ConfigFileEntry.netid : "bnet";
+
+  if (s) 
+    {
+      unsigned int h = 0;
+
+      while (*s)
+		{
+	  		h = (h << 4) - (h + (unsigned char)ToLower(*s++));
+		}
+
+      n = h & (U_MAX - 1);
+
+      strcpy(buf, netid);
+      p = buf + strlen(netid);
+    }
+  else
+    *p++ = '.';
+
+  srandom(n);
+
+  for (n = 0; n < 6; n++)
+    *p++ = '0' + random() % 10;
+
+  if (s)
+    *p++ = '.';
+
+  *p = 0;
+
+  return buf;
+}
+
 /*
  * register_remote_user
  *
@@ -530,6 +641,10 @@
   if (++Count.total > Count.max_tot)
     Count.max_tot = Count.total;
 
+  if (source_p->svsflags & FLAGS_SVS_IDENT)
+    if (++Count.identified > Count.max_identified)
+      Count.max_identified = Count.identified;
+
   source_p->servptr = find_server(user->server);
 
   if (source_p->servptr == NULL)
@@ -580,6 +695,14 @@
       return exit_client(source_p, source_p, &me, "Ghosted Client");
     }
 
+  if (client_p->eob && strcmp(source_p->ip, "<burst>") && !IsRelay(source_p->servptr))
+	  sendto_realops_flags(FLAGS_REMOTE, L_ALL,
+	  		"Remote client: %s (%s@%s) [%s] {%s}",
+	  		nick, username, source_p->realhost, source_p->ip, source_p->user->server);
+
+  if (IsPerson(source_p))
+	  hash_check_watch(source_p, RPL_LOGON);
+
   return (introduce_client(client_p, source_p, user, nick));
 }
 
@@ -592,13 +715,14 @@
  *		  of the net, either from a local client connect or
  *		  from a remote connect.
  */
-static int
+int
 introduce_client(struct Client *client_p, struct Client *source_p,
 		 struct User *user, char *nick)
 {
   dlink_node *server_node;
   struct Client *server;
   static char ubuf[12];
+  unsigned int svshopcount;
 
   if(MyClient(source_p))
     send_umode(source_p, source_p, 0, SEND_UMODES, ubuf);
@@ -631,53 +755,59 @@
   if (!ServerInfo.hub && uplink && IsCapable(uplink,CAP_LL)
       && client_p != uplink) 
     {
+      if (IsCapable(uplink, CAP_SVS))
+        svshopcount = source_p->hopcount + 1 + (source_p->svsflags << 8);
+      else 
+        svshopcount = source_p->hopcount + 1;
+
       if (IsCapable(uplink, CAP_UID) && HasID(source_p))
-	{
-	  sendto_one(uplink, "CLIENT %s %d %lu %s %s %s %s %s :%s",
-		     nick,
-		     source_p->hopcount+1,
-		     (unsigned long) source_p->tsinfo,
-		     ubuf,
-		     source_p->username, source_p->host, user->server,
-		     user->id, source_p->info);
-	}
+		{
+          sendto_one(uplink, "CLIENT %s %d %lu %s %s %s %s %s %s %s :%s",
+                     nick, svshopcount, source_p->tsinfo,
+                     ubuf, source_p->username, source_p->host, user->server,
+                     user->id, IsCapable(uplink, CAP_HOSTMASK)?
+                     source_p->realhost : "", IsCapable(uplink, CAP_IP)?
+                     source_p->ip : "", source_p->info);
+		}
       else
-	{
-	  sendto_one(uplink, "NICK %s %d %lu %s %s %s %s :%s",
-		     nick,
-		     source_p->hopcount+1,
-		     (unsigned long) source_p->tsinfo,
-		     ubuf,
-		     source_p->username, source_p->host, user->server,
-		     source_p->info);
-	}
+		{
+          sendto_one(uplink, "NICK %s %d %lu %s %s %s %s %s %s :%s",
+                     nick, svshopcount, source_p->tsinfo,
+                     ubuf, source_p->username, source_p->host, user->server,
+                     IsCapable(uplink, CAP_HOSTMASK)? source_p->realhost : "",
+                     IsCapable(uplink, CAP_IP)? source_p->ip : "",
+                     source_p->info);
+		}
     }
   else
     {
       for (server_node = serv_list.head; server_node; server_node = server_node->next)
-	{
-	  server = (struct Client *) server_node->data;
+		{
+	  	  server = (struct Client *) server_node->data;
 		  
-	  if (IsCapable(server, CAP_LL) || server == client_p)
-	    continue;
+	  	  if (IsCapable(server, CAP_LL) || server == client_p)
+	    	continue;
 		  
-	  if (IsCapable(server, CAP_UID) && HasID(source_p))
-	    sendto_one(server, "CLIENT %s %d %lu %s %s %s %s %s :%s",
-		       nick,
-		       source_p->hopcount+1,
-		       (unsigned long) source_p->tsinfo,
-		       ubuf,
-		       source_p->username, source_p->host, user->server,
-		       user->id, source_p->info);
-	  else
-	    sendto_one(server, "NICK %s %d %lu %s %s %s %s :%s",
-		       nick,
-		       source_p->hopcount+1,
-		       (unsigned long) source_p->tsinfo,
-		       ubuf,
-		       source_p->username, source_p->host, user->server,
-		       source_p->info);
-	}
+          if (IsCapable(server, CAP_SVS))
+            svshopcount = source_p->hopcount + 1 + (source_p->svsflags << 8);
+          else 
+            svshopcount = source_p->hopcount + 1;
+		  
+	  	  if (IsCapable(server, CAP_UID) && HasID(source_p))
+            sendto_one(server, "CLIENT %s %d %lu %s %s %s %s %s %s %s :%s",
+                       nick, svshopcount, source_p->tsinfo,
+                       ubuf, source_p->username, source_p->host, user->server,
+                       user->id, IsCapable(server, CAP_HOSTMASK)?
+                       source_p->realhost : "", IsCapable(server, CAP_IP)?
+                       source_p->ip : "", source_p->info);
+	  	  else
+            sendto_one(server, "NICK %s %d %lu %s %s %s %s %s %s :%s",
+                       nick, svshopcount, source_p->tsinfo,
+                       ubuf, source_p->username, source_p->host, user->server,
+                       IsCapable(server, CAP_HOSTMASK)? source_p->realhost : "",
+                       IsCapable(server, CAP_IP)? source_p->ip : "",
+                       source_p->info);
+		}
     }
   
   return 0;
@@ -842,6 +972,8 @@
 		  char* username, char *host, char *server, char *realname)
 {
   struct User* user;
+  char *hend = host + strlen(host) - 1;
+  char *send = server + strlen(server) - 1;
 
   assert(NULL != source_p);
   assert(source_p->username != username);
@@ -851,9 +983,15 @@
 
   user = make_user(source_p);
 
+  /* mIRC kludge here */
+  if (*host=='"' && *hend=='"' && *server=='"' && *send=='"')
+	  user->known = 1;
+  else
+	  user->known = IsUserPar(host, server);
+
   if (!IsUnknown(source_p))
     {
-      sendto_one(source_p, form_str(ERR_ALREADYREGISTRED), me.name, nick);
+      sendto_one(source_p, form_str(source_p,ERR_ALREADYREGISTRED), me.name, nick);
       return 0;
     }
     
@@ -891,7 +1029,7 @@
 int
 do_remote_user(char* nick, struct Client* client_p, struct Client* source_p,
 		   char* username, char *host, char *server, char *realname,
-		   char *id)
+		   char *realhost, char *ip, char *id)
 {
   unsigned int oflags;
   struct User* user;
@@ -913,6 +1051,19 @@
   strlcpy(source_p->info, realname, sizeof(source_p->info));
   if (id != NULL)
     strcpy(source_p->user->id, id);
+
+  if (realhost)
+    strcpy(source_p->realhost, realhost);
+  else
+    strcpy(source_p->realhost, "<none>");
+
+  if (client_p->eob) {
+	if (ip)
+		strcpy(source_p->ip, ip);
+	else
+		strcpy(source_p->ip, "255.255.255.255");
+  } else
+	  strcpy(source_p->ip, "<burst>");
   
   return register_remote_user(client_p, source_p, source_p->name, username);
 }
@@ -940,7 +1091,7 @@
 
   if (parc < 2)
     {
-      sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS),
+      sendto_one(source_p, form_str(source_p,ERR_NEEDMOREPARAMS),
                  me.name, parv[0], "MODE");
       return 0;
     }
@@ -948,7 +1099,7 @@
   if ((target_p = find_person(parv[1])) == NULL)
     {
       if (MyConnect(source_p))
-        sendto_one(source_p, form_str(ERR_NOSUCHCHANNEL),
+        sendto_one(source_p, form_str(source_p,ERR_NOSUCHCHANNEL),
                    me.name, parv[0], parv[1]);
       return 0;
     }
@@ -966,7 +1117,7 @@
 
   if (source_p != target_p || target_p->from != source_p->from)
     {
-       sendto_one(source_p, form_str(ERR_USERSDONTMATCH), me.name, parv[0]);
+       sendto_one(source_p, form_str(source_p,ERR_USERSDONTMATCH), me.name, parv[0]);
        return 0;
     }
 
@@ -980,7 +1131,7 @@
         if (source_p->umodes & user_modes[i].mode)
           *m++ = user_modes[i].letter;
       *m = '\0';
-      sendto_one(source_p, form_str(RPL_UMODEIS), me.name, parv[0], buf);
+      sendto_one(source_p, form_str(source_p,RPL_UMODEIS), me.name, parv[0], buf);
       return 0;
     }
 
@@ -1073,7 +1224,7 @@
         }
 
   if(badflag)
-    sendto_one(source_p, form_str(ERR_UMODEUNKNOWNFLAG), me.name, parv[0]);
+    sendto_one(source_p, form_str(source_p,ERR_UMODEUNKNOWNFLAG), me.name, parv[0]);
 
   if ((source_p->umodes & FLAGS_NCHANGE) && !IsOperN(source_p))
     {
@@ -1204,10 +1355,10 @@
 void
 user_welcome(struct Client *source_p)
 {
-  sendto_one(source_p, form_str(RPL_WELCOME), me.name, source_p->name, 
+  sendto_one(source_p, form_str(source_p,RPL_WELCOME), me.name, source_p->name, 
              ServerInfo.network_name, source_p->name );
   /* This is a duplicate of the NOTICE but see below...*/
-  sendto_one(source_p, form_str(RPL_YOURHOST), me.name, source_p->name,
+  sendto_one(source_p, form_str(source_p,RPL_YOURHOST), me.name, source_p->name,
 	     get_listener_name(source_p->localClient->listener), ircd_version);
   
   /*
@@ -1217,9 +1368,21 @@
 	     "NOTICE %s :*** Your host is %s, running version %s",
 	     source_p->name, get_listener_name(source_p->localClient->listener),
 	     ircd_version);
+	     
+#ifdef HAVE_LIBCRYPTO
+  {
+  	int fd = source_p->localClient->fd;
+  	fde_t *F = (fd > -1)? &fd_table[fd] : NULL;
+  	extern char *ssl_get_cipher(SSL *);
+  	
+  	if (F && F->ssl)
+  		sendto_one(source_p, "NOTICE %s :*** Connected securely via %s",
+  		source_p->name, ssl_get_cipher(F->ssl));
+  }
+#endif	     
   
-  sendto_one(source_p, form_str(RPL_CREATED),me.name,source_p->name,creation);
-  sendto_one(source_p, form_str(RPL_MYINFO), me.name, source_p->name,
+  sendto_one(source_p, form_str(source_p,RPL_CREATED),me.name,source_p->name,creation);
+  sendto_one(source_p, form_str(source_p,RPL_MYINFO), me.name, source_p->name,
 	     me.name, ircd_version);
   
   show_isupport(source_p);
@@ -1236,16 +1399,16 @@
 		 "NOTICE %s :*** Notice -- Please read the motd if you haven't read it",
 		 source_p->name);
     
-      sendto_one(source_p, form_str(RPL_MOTDSTART),
+      sendto_one(source_p, form_str(source_p,RPL_MOTDSTART),
 		 me.name, source_p->name, me.name);
     
       sendto_one(source_p,
-		 form_str(RPL_MOTD),
+		 form_str(source_p,RPL_MOTD),
 		 me.name, source_p->name,
 		 "*** This is the short motd ***"
 		 );
 
-      sendto_one(source_p, form_str(RPL_ENDOFMOTD),
+      sendto_one(source_p, form_str(source_p,RPL_ENDOFMOTD),
 		 me.name, source_p->name);
     }
   else  
@@ -1253,7 +1416,7 @@
 
   if (IsRestricted(source_p))
     {
-      sendto_one(source_p,form_str(ERR_RESTRICTED),
+      sendto_one(source_p,form_str(source_p,ERR_RESTRICTED),
 		 me.name, source_p->name);
     }
 }
@@ -1375,7 +1538,7 @@
 		       "%s (%s@%s) is now an operator", source_p->name,
 		       source_p->username, source_p->host);
   send_umode_out(source_p, source_p, old);
-  sendto_one(source_p, form_str(RPL_YOUREOPER), me.name, source_p->name);
+  sendto_one(source_p, form_str(source_p,RPL_YOUREOPER), me.name, source_p->name);
   sendto_one(source_p, ":%s NOTICE %s :*** Oper privs are %s", me.name,
              source_p->name, operprivs);
   SendMessageFile(source_p, &ConfigFileEntry.opermotd);
diff -uNrd -x CVS ircd-hybrid-7rc5/src/scache.c ircd-hybrid-7-bg/src/scache.c
--- ircd-hybrid-7rc5/src/scache.c	Thu Oct 10 14:49:31 2002
+++ ircd-hybrid-7-bg/src/scache.c	Mon Dec 30 23:07:27 2002
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: scache.c,v 7.17 2002/10/10 18:49:31 androsyn Exp $
+ *  $Id: scache.c,v 1.1.1.1 2002/12/31 04:07:27 demond Exp $
  */
 
 #include "stdinc.h"
diff -uNrd -x CVS ircd-hybrid-7rc5/src/send.c ircd-hybrid-7-bg/src/send.c
--- ircd-hybrid-7rc5/src/send.c	Wed Sep 18 23:12:01 2002
+++ ircd-hybrid-7-bg/src/send.c	Mon Mar 10 01:09:06 2003
@@ -19,13 +19,14 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: send.c,v 7.207 2002/09/19 03:12:01 bill Exp $
+ *  $Id: send.c,v 1.4 2003/03/10 06:09:06 demond Exp $
  */
 
 #include "stdinc.h"
 #include "tools.h"
 #include "send.h"
 #include "channel.h"
+#include "channel_mode.h"
 #include "class.h"
 #include "client.h"
 #include "common.h"
@@ -76,6 +77,7 @@
                      dlink_list *list, buf_head_t *local_linebuf,
                      buf_head_t *remote_linebuf, buf_head_t *uid_linebuf);
 
+static int marknick(struct Client *client_p, char *buf);
 
 /*
  * send_trim
@@ -241,7 +243,7 @@
     to->flags |= FLAGS_KILLED;
 
     if (IsPerson(from))
-      sendto_one(from, form_str(ERR_GHOSTEDCLIENT),
+      sendto_one(from, form_str(from,ERR_GHOSTEDCLIENT),
                  me.name, from->name, to->name, to->username,
                  to->host, to->from);
 
@@ -575,6 +577,15 @@
   dlink_node *ptr;
   dlink_node *ptr_next;
   struct Client *target_p;
+  buf_head_t my_winbuf, my_isobuf;
+  int windone = 0, isodone = 0;
+  buf_line_t *bl;
+  
+  linebuf_newbuf(&my_winbuf);
+  linebuf_newbuf(&my_isobuf);
+  bl = (buf_line_t *)local_linebuf->list.tail->data;
+  linebuf_putmsg(&my_winbuf, NULL, NULL, "%s", bl->buf);
+  linebuf_putmsg(&my_isobuf, NULL, NULL, "%s", bl->buf);
 
   DLINK_FOREACH_SAFE(ptr, ptr_next, list->head)
   {
@@ -585,9 +596,43 @@
 
     if (MyConnect(target_p) && IsRegisteredUser(target_p) && !IsDead(target_p))
     {
-      if(target_p->serial != current_serial)
+      if (target_p->serial != current_serial)
       {
-        send_linebuf(target_p, local_linebuf);
+      	/*buf_line_t *bl = (buf_line_t *)local_linebuf->list.tail->data;
+	    int mark = marknick(target_p, bl->buf);
+		
+		if (mark) {
+			bl->len++; local_linebuf->len++;
+		}
+					
+		translate(target_p, bl->buf);*/
+		if (IsSetTransWin(target_p)) {
+		
+			if (!windone) {
+				bl = (buf_line_t *)my_winbuf.list.tail->data;
+				translate(target_p, bl->buf);
+				windone = 1;
+			}
+			send_linebuf(target_p, &my_winbuf);
+			
+		} else if (IsSetTransISO(target_p)) {
+		
+			if (!isodone) {
+				bl = (buf_line_t *)my_isobuf.list.tail->data;
+				translate(target_p, bl->buf);
+				isodone = 1;
+			}
+			send_linebuf(target_p, &my_isobuf);
+			
+		} else
+        	send_linebuf(target_p, local_linebuf);
+        
+        /*if (mark) {
+        	char *p = bl->buf;
+        	while (*p++) *(p-1) = *p; 
+        	bl->len--; local_linebuf->len--;
+        }*/
+        	
         target_p->serial = current_serial;
       }
     }
@@ -607,6 +652,9 @@
       }
     }
   }
+  
+  linebuf_donebuf(&my_winbuf);
+  linebuf_donebuf(&my_isobuf);
 }
 
 /*
@@ -707,6 +755,43 @@
 }
 
 /*
+ * add to channel NICK/QUIT pace queue
+ */
+void add_pace_send(struct Channel *chptr, char *sendbuf, int len)
+{
+  struct Pace *pace = MyMalloc(sizeof(struct Pace) + strlen(chptr->chname));
+
+  strcpy(pace->chan, chptr->chname);
+
+  pace->next = NULL;
+  pace->shownames = len;
+  pace->text = MyMalloc(strlen(sendbuf) + 1);
+  strcpy(pace->text, sendbuf);
+
+  if (chptr->sendh)
+    chptr->sendh->next = pace;
+  chptr->sendh = pace;
+  if (!chptr->sendt)
+    chptr->sendt = pace;
+
+  chptr->sends++;
+}
+
+void sendto_chanlists_local(struct Channel *chptr, char *sendbuf, int len)
+{
+  buf_head_t lb;
+  linebuf_newbuf(&lb);
+  linebuf_putmsg(&lb, NULL, NULL, "%s", sendbuf);
+
+  sendto_list_local(&chptr->chanops, &lb);
+  sendto_list_local(&chptr->halfops, &lb);
+  sendto_list_local(&chptr->voiced, &lb);
+  sendto_list_local(&chptr->peons, &lb);
+  
+  linebuf_donebuf(&lb);
+}
+
+/*
  * sendto_common_channels_local()
  *
  * inputs	- pointer to client
@@ -738,6 +823,13 @@
     {
       chptr = ptr->data;
 
+	  if (PaceChannel(chptr) && (chptr->sends < MAX_PACESEND))
+	  	{
+	  		buf_line_t *bl = (buf_line_t *)linebuf.list.tail->data;
+	    	add_pace_send(chptr, bl->buf, bl->len);
+	    }
+	  else
+	    {
       sendto_list_local(&chptr->locchanops, &linebuf);
 #ifdef REQUIRE_OANDV
       sendto_list_local(&chptr->locchanops_voiced, &linebuf);
@@ -747,6 +839,7 @@
 #endif
       sendto_list_local(&chptr->locvoiced, &linebuf);
       sendto_list_local(&chptr->locpeons, &linebuf);
+      	}
     }
 
     if (MyConnect(user) && (user->serial != current_serial))
@@ -936,6 +1029,15 @@
   dlink_node *ptr;
   dlink_node *ptr_next;
   struct Client *target_p;
+  buf_head_t my_winbuf, my_isobuf;
+  int windone = 0, isodone = 0;
+  buf_line_t *bl;
+  
+  linebuf_newbuf(&my_winbuf);
+  linebuf_newbuf(&my_isobuf);
+  bl = (buf_line_t *)linebuf_ptr->list.tail->data;
+  linebuf_putmsg(&my_winbuf, NULL, NULL, "%s", bl->buf);
+  linebuf_putmsg(&my_isobuf, NULL, NULL, "%s", bl->buf);
 
   DLINK_FOREACH_SAFE(ptr, ptr_next, list->head)
   {
@@ -950,8 +1052,49 @@
 
     target_p->serial = current_serial;
 
-    send_linebuf(target_p, linebuf_ptr);
+	if (ConfigFileEntry.totaltrans)
+	  {
+      	/*buf_line_t *bl = (buf_line_t *)linebuf_ptr->list.tail->data;
+	    int mark = marknick(target_p, bl->buf);
+		
+		if (mark) {
+			bl->len++; linebuf_ptr->len++;
+		}
+					
+		translate(target_p, bl->buf);*/
+		if (IsSetTransWin(target_p)) {
+		
+			if (!windone) {
+				bl = (buf_line_t *)my_winbuf.list.tail->data;
+				translate(target_p, bl->buf);
+				windone = 1;
+			}
+			send_linebuf(target_p, &my_winbuf);
+			
+		} else if (IsSetTransISO(target_p)) {
+		
+			if (!isodone) {
+				bl = (buf_line_t *)my_isobuf.list.tail->data;
+				translate(target_p, bl->buf);
+				isodone = 1;
+			}
+			send_linebuf(target_p, &my_isobuf);
+			
+		} else
+        send_linebuf(target_p, linebuf_ptr);
+        
+        /*if (mark) {
+        	char *p = bl->buf;
+        	while (*p++) *(p-1) = *p; 
+        	bl->len--; linebuf_ptr->len--;
+        }*/
+	  }
+	else
+    	send_linebuf(target_p, linebuf_ptr);
   } 
+  
+  linebuf_donebuf(&my_winbuf);
+  linebuf_donebuf(&my_isobuf);
 } /* sendto_list_local() */
 
 /*
@@ -1439,4 +1582,34 @@
   if (have_uid)
     linebuf_donebuf(&linebuf_uid);
   linebuf_donebuf(&linebuf_nick);
+} 
+
+/*
+ * this puts '?' in front of a translated cyrillic nick buffer
+ *												-demond
+ */
+static int marknick(struct Client *client_p, char *buf)
+{
+  unsigned char *p = buf;
+
+  if (!ConfigFileEntry.cyrillic)
+    return 0;
+
+  if (!IsSetTransWin(client_p) && !IsSetTransISO(client_p))
+    return 0;
+
+  while (*p && *p!=' ')
+    {
+      if (*p++ >= 192)
+		{
+	  		p = buf + strlen(buf);
+	  		while (p-- >= (unsigned char *)buf)
+	    		*(p+2) = *(p+1);
+
+	  		buf[0]=':'; buf[1]='?';
+	  		return 1;
+		}
+    }
+
+  return 0;
 } 
diff -uNrd -x CVS ircd-hybrid-7rc5/src/snprintf.c ircd-hybrid-7-bg/src/snprintf.c
--- ircd-hybrid-7rc5/src/snprintf.c	Fri May 24 19:34:52 2002
+++ ircd-hybrid-7-bg/src/snprintf.c	Mon Dec 30 23:07:27 2002
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: snprintf.c,v 1.6 2002/05/24 23:34:52 androsyn Exp $
+ *  $Id: snprintf.c,v 1.1.1.1 2002/12/31 04:07:27 demond Exp $
  */
 
 /**************************************************************
diff -uNrd -x CVS ircd-hybrid-7rc5/src/sprintf_irc.c ircd-hybrid-7-bg/src/sprintf_irc.c
--- ircd-hybrid-7rc5/src/sprintf_irc.c	Wed Jun 12 14:57:52 2002
+++ ircd-hybrid-7-bg/src/sprintf_irc.c	Mon Dec 30 23:07:27 2002
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: sprintf_irc.c,v 7.15 2002/06/12 18:57:52 androsyn Exp $
+ *  $Id: sprintf_irc.c,v 1.1.1.1 2002/12/31 04:07:27 demond Exp $
  */
 
 #include "stdinc.h"
diff -uNrd -x CVS ircd-hybrid-7rc5/src/tools.c ircd-hybrid-7-bg/src/tools.c
--- ircd-hybrid-7rc5/src/tools.c	Thu Aug 22 19:08:40 2002
+++ ircd-hybrid-7-bg/src/tools.c	Thu Jan 30 10:29:01 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: tools.c,v 7.25 2002/08/22 23:08:40 db Exp $
+ *  $Id: tools.c,v 1.2 2003/01/30 15:29:01 demond Exp $
  *
  * When you update these functions make sure you update the ones in tools.h
  * as well!!!
@@ -202,3 +202,32 @@
   }
   return(NULL);
 }
+
+#ifdef HAVE_LIBCRYPTO
+static struct {
+	int err;
+	char *str;
+} errtab[] = {
+	{SSL_ERROR_NONE, "SSL_ERROR_NONE"},
+	{SSL_ERROR_ZERO_RETURN, "SSL_ERROR_ZERO_RETURN"},
+	{SSL_ERROR_WANT_READ, "SSL_ERROR_WANT_READ"},
+	{SSL_ERROR_WANT_WRITE, "SSL_ERROR_WANT_WRITE"},
+	{SSL_ERROR_WANT_CONNECT, "SSL_ERROR_WANT_CONNECT"},
+	/*{SSL_ERROR_WANT_ACCEPT, "SSL_ERROR_WANT_ACCEPT"},*/
+	{SSL_ERROR_WANT_X509_LOOKUP, "SSL_ERROR_WANT_X509_LOOKUP"},
+	{SSL_ERROR_SYSCALL, "SSL_ERROR_SYSCALL"},
+	{SSL_ERROR_SSL, "SSL_ERROR_SSL"},
+	{-1, NULL}
+};
+
+char *get_ssl_error(int sslerr) 
+{
+	int i;
+	
+	for (i=0; errtab[i].err != -1; i++)
+		if (errtab[i].err == sslerr)
+			return errtab[i].str;
+			
+	return "<NULL>";
+}
+#endif
